use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum IntegrationDetails {
    SlackWebhookIntegration(super::SlackWebhookIntegration),
    OpsgenieIntegration(super::OpsgenieIntegration),
    SimpleWebhookIntegration(super::SimpleWebhookIntegration),
    SecureWebhookIntegration(super::SecureWebhookIntegration),
    TeamsWebhookIntegration(super::TeamsWebhookIntegration),
    PagerDutyIntegration(super::PagerDutyIntegration),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for IntegrationDetails {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            IntegrationDetails::SlackWebhookIntegration(value) => {
                map.serialize_entry(&"type", &"slackWebhookIntegration")?;
                map.serialize_entry(&"slackWebhookIntegration", value)?;
            }
            IntegrationDetails::OpsgenieIntegration(value) => {
                map.serialize_entry(&"type", &"opsgenieIntegration")?;
                map.serialize_entry(&"opsgenieIntegration", value)?;
            }
            IntegrationDetails::SimpleWebhookIntegration(value) => {
                map.serialize_entry(&"type", &"simpleWebhookIntegration")?;
                map.serialize_entry(&"simpleWebhookIntegration", value)?;
            }
            IntegrationDetails::SecureWebhookIntegration(value) => {
                map.serialize_entry(&"type", &"secureWebhookIntegration")?;
                map.serialize_entry(&"secureWebhookIntegration", value)?;
            }
            IntegrationDetails::TeamsWebhookIntegration(value) => {
                map.serialize_entry(&"type", &"teamsWebhookIntegration")?;
                map.serialize_entry(&"teamsWebhookIntegration", value)?;
            }
            IntegrationDetails::PagerDutyIntegration(value) => {
                map.serialize_entry(&"type", &"pagerDutyIntegration")?;
                map.serialize_entry(&"pagerDutyIntegration", value)?;
            }
            IntegrationDetails::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for IntegrationDetails {
    fn deserialize<D>(d: D) -> Result<IntegrationDetails, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = IntegrationDetails;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union IntegrationDetails")
    }
    fn visit_map<A>(self, mut map: A) -> Result<IntegrationDetails, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (
                        Variant_::SlackWebhookIntegration,
                        Some(Variant_::SlackWebhookIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::SlackWebhookIntegration(value)
                    }
                    (
                        Variant_::OpsgenieIntegration,
                        Some(Variant_::OpsgenieIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::OpsgenieIntegration(value)
                    }
                    (
                        Variant_::SimpleWebhookIntegration,
                        Some(Variant_::SimpleWebhookIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::SimpleWebhookIntegration(value)
                    }
                    (
                        Variant_::SecureWebhookIntegration,
                        Some(Variant_::SecureWebhookIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::SecureWebhookIntegration(value)
                    }
                    (
                        Variant_::TeamsWebhookIntegration,
                        Some(Variant_::TeamsWebhookIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::TeamsWebhookIntegration(value)
                    }
                    (
                        Variant_::PagerDutyIntegration,
                        Some(Variant_::PagerDutyIntegration),
                    ) => {
                        let value = map.next_value()?;
                        IntegrationDetails::PagerDutyIntegration(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            IntegrationDetails::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::SlackWebhookIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::SlackWebhookIntegration(value)
                    }
                    Variant_::OpsgenieIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::OpsgenieIntegration(value)
                    }
                    Variant_::SimpleWebhookIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::SimpleWebhookIntegration(value)
                    }
                    Variant_::SecureWebhookIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::SecureWebhookIntegration(value)
                    }
                    Variant_::TeamsWebhookIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::TeamsWebhookIntegration(value)
                    }
                    Variant_::PagerDutyIntegration => {
                        let value = map.next_value()?;
                        IntegrationDetails::PagerDutyIntegration(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        IntegrationDetails::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    SlackWebhookIntegration,
    OpsgenieIntegration,
    SimpleWebhookIntegration,
    SecureWebhookIntegration,
    TeamsWebhookIntegration,
    PagerDutyIntegration,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::SlackWebhookIntegration => "slackWebhookIntegration",
            Variant_::OpsgenieIntegration => "opsgenieIntegration",
            Variant_::SimpleWebhookIntegration => "simpleWebhookIntegration",
            Variant_::SecureWebhookIntegration => "secureWebhookIntegration",
            Variant_::TeamsWebhookIntegration => "teamsWebhookIntegration",
            Variant_::PagerDutyIntegration => "pagerDutyIntegration",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "slackWebhookIntegration" => Variant_::SlackWebhookIntegration,
            "opsgenieIntegration" => Variant_::OpsgenieIntegration,
            "simpleWebhookIntegration" => Variant_::SimpleWebhookIntegration,
            "secureWebhookIntegration" => Variant_::SecureWebhookIntegration,
            "teamsWebhookIntegration" => Variant_::TeamsWebhookIntegration,
            "pagerDutyIntegration" => Variant_::PagerDutyIntegration,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the IntegrationDetails union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
